/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.152 Revision 1.212
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.152 2005/02/18 18:04:42 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.212 2005/10/22 02:32:48 vapier Exp $
4# 4#
5# Author: Martin Schlemmer <azarah@gentoo.org> 5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 6#
7# This eclass is for general purpose functions that most ebuilds 7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 8# have to implement themselves.
9# 9#
10# NB: If you add anything, please comment it! 10# NB: If you add anything, please comment it!
11 11
12inherit multilib 12inherit multilib portability
13ECLASS=eutils
14INHERITED="$INHERITED $ECLASS"
15 13
16DEPEND="!bootstrap? ( sys-devel/patch )" 14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745.
17 16
18DESCRIPTION="Based on the ${ECLASS} eclass" 17DESCRIPTION="Based on the ${ECLASS} eclass"
19
20# ecpu_check
21# Usage:
22#
23# ecpu_check array_of_cpu_flags
24#
25# array_of_cpu_flags - An array of cpu flags to check against USE flags
26#
27# Checks user USE related cpu flags against /proc/cpuinfo. If user enables a
28# cpu flag that is not supported in their processor flags, it will warn the
29# user if CROSSCOMPILE is not set to 1 ( because cross compile users are
30# obviously using different cpu flags than their own cpu ). Examples:
31#
32# CPU_FLAGS=(mmx mmx2 sse sse2)
33# ecpu_check CPU_FLAGS
34# Chris White <chriswhite@gentoo.org> (03 Feb 2005)
35
36ecpu_check() {
37 # Think about changing below to: if [ "${CROSSCOMPILE}" -ne 1 -a -e "/proc/cpuinfo" ]
38 # and dropping the else if you do not plan on adding anything to that
39 # empty block ....
40 # PS: also try to add some quoting, and consider rather using ${foo} than $foo ...
41 if [ "${CROSSCOMPILE}" != "1" -a -e "/proc/cpuinfo" ]
42 then
43 CPU_FLAGS=${1}
44 USER_CPU=`grep "flags" /proc/cpuinfo`
45
46 for flags in `seq 1 ${#CPU_FLAGS[@]}`
47 do
48 if has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && ! has ${CPU_FLAGS[${flags} - 1]} ${USE}
49 then
50 ewarn "Your system is ${CPU_FLAGS[${flags} - 1]} capable but you don't have it enabled!"
51 ewarn "You might be cross compiling (in this case set CROSSCOMPILE to 1 to disable this warning."
52 fi
53
54 if ! has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && has ${CPU_FLAGS[${flags} -1]} ${USE}
55 then
56 ewarn "You have ${CPU_FLAGS[${flags} - 1]} support enabled but your processor doesn't"
57 ewarn "Seem to support it! You might be cross compiling or do not have /proc filesystem"
58 ewarn "enabled. If either is the case, set CROSSCOMPILE to 1 to disable this warning."
59 fi
60 done
61 fi
62}
63 18
64# Wait for the supplied number of seconds. If no argument is supplied, defaults 19# Wait for the supplied number of seconds. If no argument is supplied, defaults
65# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not
66# outputting to a terminal, don't wait. For compatability purposes, the argument 21# outputting to a terminal, don't wait. For compatability purposes, the argument
67# must be an integer greater than zero. 22# must be an integer greater than zero.
109gen_usr_ldscript() { 64gen_usr_ldscript() {
110 local libdir="$(get_libdir)" 65 local libdir="$(get_libdir)"
111 # Just make sure it exists 66 # Just make sure it exists
112 dodir /usr/${libdir} 67 dodir /usr/${libdir}
113 68
69 for lib in "${@}" ; do
114 cat > "${D}/usr/${libdir}/${1}" << END_LDSCRIPT 70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
115/* GNU ld script 71 /* GNU ld script
116 Because Gentoo have critical dynamic libraries 72 Since Gentoo has critical dynamic libraries
117 in /lib, and the static versions in /usr/lib, we 73 in /lib, and the static versions in /usr/lib,
118 need to have a "fake" dynamic lib in /usr/lib, 74 we need to have a "fake" dynamic lib in /usr/lib,
119 otherwise we run into linking problems. 75 otherwise we run into linking problems.
120 See bug #4411 on http://bugs.gentoo.org/ for 76
121 more info. */ 77 See bug http://bugs.gentoo.org/4411 for more info.
78 */
122GROUP ( /${libdir}/${1} ) 79 GROUP ( /${libdir}/${lib} )
123END_LDSCRIPT 80 END_LDSCRIPT
124 fperms a+x "/usr/${libdir}/${1}" 81 fperms a+x "/usr/${libdir}/${lib}"
82 done
125} 83}
126 84
127# Simple function to draw a line consisting of '=' the same length as $* 85# Simple function to draw a line consisting of '=' the same length as $*
86# - only to be used by epatch()
128# 87#
129# <azarah@gentoo.org> (11 Nov 2002) 88# <azarah@gentoo.org> (11 Nov 2002)
130# 89#
131draw_line() { 90draw_line() {
132 local i=0 91 local i=0
158EPATCH_SOURCE="${WORKDIR}/patch" 117EPATCH_SOURCE="${WORKDIR}/patch"
159# Default extension for patches 118# Default extension for patches
160EPATCH_SUFFIX="patch.bz2" 119EPATCH_SUFFIX="patch.bz2"
161# Default options for patch 120# Default options for patch
162# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 121# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571
163EPATCH_OPTS="-g0" 122# Set --no-backup-if-mismatch so we don't leave '.orig' files behind.
123EPATCH_OPTS="-g0 --no-backup-if-mismatch"
164# List of patches not to apply. Not this is only file names, 124# List of patches not to apply. Not this is only file names,
165# and not the full path .. 125# and not the full path ..
166EPATCH_EXCLUDE="" 126EPATCH_EXCLUDE=""
167# Change the printed message for a single patch. 127# Change the printed message for a single patch.
168EPATCH_SINGLE_MSG="" 128EPATCH_SINGLE_MSG=""
129# Change the printed message for multiple patches.
130EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
169# Force applying bulk patches even if not following the style: 131# Force applying bulk patches even if not following the style:
170# 132#
171# ??_${ARCH}_foo.${EPATCH_SUFFIX} 133# ??_${ARCH}_foo.${EPATCH_SUFFIX}
172# 134#
173EPATCH_FORCE="no" 135EPATCH_FORCE="no"
204# hand its a directory, it will set EPATCH_SOURCE to this. 166# hand its a directory, it will set EPATCH_SOURCE to this.
205# 167#
206# <azarah@gentoo.org> (10 Nov 2002) 168# <azarah@gentoo.org> (10 Nov 2002)
207# 169#
208epatch() { 170epatch() {
171 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
209 local PIPE_CMD="" 172 local PIPE_CMD=""
210 local STDERR_TARGET="${T}/$$.out" 173 local STDERR_TARGET="${T}/$$.out"
211 local PATCH_TARGET="${T}/$$.patch" 174 local PATCH_TARGET="${T}/$$.patch"
212 local PATCH_SUFFIX="" 175 local PATCH_SUFFIX=""
213 local SINGLE_PATCH="no" 176 local SINGLE_PATCH="no"
214 local x="" 177 local x=""
215 178
179 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
180
216 if [ "$#" -gt 1 ] 181 if [ "$#" -gt 1 ]
217 then 182 then
218 local m="" 183 local m=""
219 einfo "${#} patches to apply ..."
220 for m in "$@" ; do 184 for m in "$@" ; do
221 epatch "${m}" 185 epatch "${m}"
222 done 186 done
223 return 0 187 return 0
224 fi 188 fi
278 ;; 242 ;;
279 esac 243 esac
280 244
281 if [ "${SINGLE_PATCH}" = "no" ] 245 if [ "${SINGLE_PATCH}" = "no" ]
282 then 246 then
283 einfo "Applying various patches (bugfixes/updates) ..." 247 einfo "${EPATCH_MULTI_MSG}"
284 fi 248 fi
285 for x in ${EPATCH_SOURCE} 249 for x in ${EPATCH_SOURCE}
286 do 250 do
287 # New ARCH dependant patch naming scheme ... 251 # New ARCH dependant patch naming scheme ...
288 # 252 #
289 # ???_arch_foo.patch 253 # ???_arch_foo.patch
290 # 254 #
291 if [ -f ${x} ] && \ 255 if [ -f ${x} ] && \
292 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \ 256 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
293 [ "${EPATCH_FORCE}" = "yes" ]) 257 [ "${EPATCH_FORCE}" = "yes" ])
294 then 258 then
295 local count=0 259 local count=0
296 local popts="${EPATCH_OPTS}" 260 local popts="${EPATCH_OPTS}"
297 local patchname=${x##*/} 261 local patchname=${x##*/}
350 count=5 314 count=5
351 break 315 break
352 fi 316 fi
353 fi 317 fi
354 318
355 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 319 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
356 then 320 then
357 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 321 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
358 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 322 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
359 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 323 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
360 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 324 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
361 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 325 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
362 326
363 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 327 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
328 _epatch_assert
364 329
365 if [ "$?" -ne 0 ] 330 if [ "$?" -ne 0 ]
366 then 331 then
367 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 332 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
368 echo 333 echo
386 fi 351 fi
387 352
388 if [ "${count}" -eq 5 ] 353 if [ "${count}" -eq 5 ]
389 then 354 then
390 echo 355 echo
391 eerror "Failed Patch: ${patchname}!" 356 eerror "Failed Patch: ${patchname} !"
357 eerror " ( ${PATCH_TARGET} )"
392 eerror 358 eerror
393 eerror "Include in your bugreport the contents of:" 359 eerror "Include in your bugreport the contents of:"
394 eerror 360 eerror
395 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}" 361 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
396 echo 362 echo
406 then 372 then
407 einfo "Done with patching" 373 einfo "Done with patching"
408 fi 374 fi
409} 375}
410 376
411# This function return true if we are using the NPTL pthreads
412# implementation.
413#
414# <azarah@gentoo.org> (06 March 2003)
415#
416have_NPTL() {
417 cat > ${T}/test-nptl.c <<-"END"
418 #define _XOPEN_SOURCE
419 #include <unistd.h>
420 #include <stdio.h>
421
422 int main()
423 {
424 char buf[255];
425 char *str = buf;
426
427 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
428 if (NULL != str) {
429 printf("%s\n", str);
430 if (NULL != strstr(str, "NPTL"))
431 return 0;
432 }
433
434 return 1;
435 }
436 END
437
438 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ..."
439 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
440 then
441 echo "yes"
442 einfon "Checking what PTHREADS implementation we have ..."
443 if ${T}/nptl
444 then
445 return 0
446 else
447 return 1
448 fi
449 else
450 echo "no"
451 fi
452
453 return 1
454}
455
456# This function check how many cpu's are present, and then set
457# -j in MAKEOPTS accordingly.
458#
459# Thanks to nall <nall@gentoo.org> for this.
460#
461get_number_of_jobs() {
462 local jobs=0
463
464 return 0
465
466 if [ ! -r /proc/cpuinfo ]
467 then
468 return 1
469 fi
470
471 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
472 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
473 then
474 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
475 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
476 ADMINPARAM="${ADMINPARAM/-j}"
477 fi
478
479 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
480
481 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
482 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
483 then
484 # these archs will always have "[Pp]rocessor"
485 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
486
487 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
488 then
489 # sparc always has "ncpus active"
490 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
491
492 elif [ "${ARCH}" = "alpha" ]
493 then
494 # alpha has "cpus active", but only when compiled with SMP
495 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
496 then
497 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
498 else
499 jobs=2
500 fi
501
502 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
503 then
504 # ppc has "processor", but only when compiled with SMP
505 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
506 then
507 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
508 else
509 jobs=2
510 fi
511 elif [ "${ARCH}" = "s390" ]
512 then
513 # s390 has "# processors : "
514 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
515 else
516 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
517 die "Unknown ARCH -- ${ARCH}!"
518 fi
519
520 # Make sure the number is valid ...
521 if [ "${jobs}" -lt 1 ]
522 then
523 jobs=1
524 fi
525
526 if [ -n "${ADMINPARAM}" ]
527 then
528 if [ "${jobs}" -gt "${ADMINPARAM}" ]
529 then
530 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge ..."
531 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
532 else
533 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge ..."
534 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
535 fi
536 fi
537}
538
539# Cheap replacement for when debianutils (and thus mktemp) 377# Cheap replacement for when debianutils (and thus mktemp)
540# does not exist on the users system 378# does not exist on the users system
541# vapier@gentoo.org 379# vapier@gentoo.org
542# 380#
543# Takes just 1 optional parameter (the directory to create tmpfile in) 381# Takes just 1 optional parameter (the directory to create tmpfile in)
544emktemp() { 382emktemp() {
545 local exe="touch" 383 local exe="touch"
546 [ "$1" == "-d" ] && exe="mkdir" && shift 384 [[ $1 == -d ]] && exe="mkdir" && shift
547 local topdir="$1" 385 local topdir=$1
548 386
549 if [ -z "${topdir}" ] 387 if [[ -z ${topdir} ]] ; then
550 then
551 [ -z "${T}" ] \ 388 [[ -z ${T} ]] \
552 && topdir="/tmp" \ 389 && topdir="/tmp" \
553 || topdir="${T}" 390 || topdir=${T}
554 fi 391 fi
555 392
556 if [ -z "$(type -p mktemp)" ] 393 if [[ -z $(type -p mktemp) ]] ; then
557 then
558 local tmp=/ 394 local tmp=/
559 while [ -e "${tmp}" ] ; do 395 while [[ -e ${tmp} ]] ; do
560 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}" 396 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
561 done 397 done
562 ${exe} "${tmp}" 398 ${exe} "${tmp}" || ${exe} -p "${tmp}"
563 echo "${tmp}" 399 echo "${tmp}"
564 else 400 else
565 [ "${exe}" == "touch" ] \ 401 [[ ${exe} == "touch" ]] \
566 && exe="-p" \ 402 && exe="-p" \
567 || exe="-d" 403 || exe="-d"
568 mktemp ${exe} "${topdir}" 404 mktemp ${exe} "${topdir}"
569 fi 405 fi
570} 406}
574# Joe Jezak <josejx@gmail.com> and usata@gentoo.org 410# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
575# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org> 411# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
576# 412#
577# egetent(database, key) 413# egetent(database, key)
578egetent() { 414egetent() {
579 if useq ppc-macos ; then 415 case ${CHOST} in
416 *-darwin*)
580 case "$2" in 417 case "$2" in
581 *[!0-9]*) # Non numeric 418 *[!0-9]*) # Non numeric
582 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 419 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
583 ;; 420 ;;
584 *) # Numeric 421 *) # Numeric
585 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 422 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
586 ;; 423 ;;
587 esac 424 esac
588 elif useq x86-fbsd ; then 425 ;;
589 local action 426 *-freebsd*)
590 if [ "$1" == "passwd" ] 427 local opts action="user"
591 then 428 [[ $1 == "passwd" ]] || action="group"
592 action="user" 429
593 else 430 # lookup by uid/gid
594 action="group" 431 if [[ $2 == [[:digit:]]* ]] ; then
432 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
595 fi 433 fi
434
596 pw show "${action}" "$2" -q 435 pw show ${action} ${opts} "$2" -q
597 else 436 ;;
437 *-netbsd*)
438 grep "$2:\*:" /etc/$1
439 ;;
440 *)
598 which nscd >& /dev/null && nscd -i "$1" 441 type -p nscd >& /dev/null && nscd -i "$1"
599 getent "$1" "$2" 442 getent "$1" "$2"
600 fi 443 ;;
444 esac
601} 445}
602 446
603# Simplify/standardize adding users to the system 447# Simplify/standardize adding users to the system
604# vapier@gentoo.org 448# vapier@gentoo.org
605# 449#
613# homedir: /dev/null 457# homedir: /dev/null
614# groups: none 458# groups: none
615# extra: comment of 'added by portage for ${PN}' 459# extra: comment of 'added by portage for ${PN}'
616enewuser() { 460enewuser() {
617 # get the username 461 # get the username
618 local euser="$1"; shift 462 local euser=$1; shift
619 if [ -z "${euser}" ] 463 if [[ -z ${euser} ]] ; then
620 then
621 eerror "No username specified !" 464 eerror "No username specified !"
622 die "Cannot call enewuser without a username" 465 die "Cannot call enewuser without a username"
623 fi 466 fi
624 467
625 # lets see if the username already exists 468 # lets see if the username already exists
626 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ] 469 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
627 then
628 return 0 470 return 0
629 fi 471 fi
630 einfo "Adding user '${euser}' to your system ..." 472 einfo "Adding user '${euser}' to your system ..."
631 473
632 # options to pass to useradd 474 # options to pass to useradd
633 local opts= 475 local opts=
634 476
635 # handle uid 477 # handle uid
636 local euid="$1"; shift 478 local euid=$1; shift
637 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ] 479 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
638 then
639 if [ "${euid}" -gt 0 ] 480 if [[ ${euid} -gt 0 ]] ; then
640 then
641 if [ ! -z "`egetent passwd ${euid}`" ] 481 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
642 then
643 euid="next" 482 euid="next"
644 fi 483 fi
645 else 484 else
646 eerror "Userid given but is not greater than 0 !" 485 eerror "Userid given but is not greater than 0 !"
647 die "${euid} is not a valid UID" 486 die "${euid} is not a valid UID"
648 fi 487 fi
649 else 488 else
650 euid="next" 489 euid="next"
651 fi 490 fi
652 if [ "${euid}" == "next" ] 491 if [[ ${euid} == "next" ]] ; then
653 then 492 for euid in $(seq 101 999) ; do
654 local pwrange
655 if [ "${USERLAND}" == "BSD" ] ; then
656 pwrange="`jot 898 101`"
657 else
658 pwrange="`seq 101 999`"
659 fi
660 for euid in ${pwrange} ; do
661 [ -z "`egetent passwd ${euid}`" ] && break 493 [[ -z $(egetent passwd ${euid}) ]] && break
662 done 494 done
663 fi 495 fi
664 opts="${opts} -u ${euid}" 496 opts="${opts} -u ${euid}"
665 einfo " - Userid: ${euid}" 497 einfo " - Userid: ${euid}"
666 498
667 # handle shell 499 # handle shell
668 local eshell="$1"; shift 500 local eshell=$1; shift
669 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ] 501 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
670 then
671 if [ ! -e "${eshell}" ] 502 if [[ ! -e ${eshell} ]] ; then
672 then
673 eerror "A shell was specified but it does not exist !" 503 eerror "A shell was specified but it does not exist !"
674 die "${eshell} does not exist" 504 die "${eshell} does not exist"
675 fi 505 fi
676 else 506 else
677 if [ "${USERLAND}" == "BSD" ] 507 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
678 then 508 [[ -x ${ROOT}${shell} ]] && break
679 eshell="/usr/bin/false" 509 done
680 else 510
681 eshell="/bin/false" 511 if [[ ${shell} == "/dev/null" ]] ; then
512 eerror "Unable to identify the shell to use"
513 die "Unable to identify the shell to use"
682 fi 514 fi
515
516 eshell=${shell}
683 fi 517 fi
684 einfo " - Shell: ${eshell}" 518 einfo " - Shell: ${eshell}"
685 opts="${opts} -s ${eshell}" 519 opts="${opts} -s ${eshell}"
686 520
687 # handle homedir 521 # handle homedir
688 local ehome="$1"; shift 522 local ehome=$1; shift
689 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ] 523 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
690 then
691 ehome="/dev/null" 524 ehome="/dev/null"
692 fi 525 fi
693 einfo " - Home: ${ehome}" 526 einfo " - Home: ${ehome}"
694 opts="${opts} -d ${ehome}" 527 opts="${opts} -d ${ehome}"
695 528
696 # handle groups 529 # handle groups
697 local egroups="$1"; shift 530 local egroups=$1; shift
698 if [ ! -z "${egroups}" ] 531 if [[ ! -z ${egroups} ]] ; then
699 then
700 local oldifs="${IFS}" 532 local oldifs=${IFS}
701 local defgroup="" exgroups="" 533 local defgroup="" exgroups=""
702 534
703 export IFS="," 535 export IFS=","
704 for g in ${egroups} 536 for g in ${egroups} ; do
705 do
706 export IFS="${oldifs}" 537 export IFS=${oldifs}
707 if [ -z "`egetent group \"${g}\"`" ] 538 if [[ -z $(egetent group "${g}") ]] ; then
708 then
709 eerror "You must add group ${g} to the system first" 539 eerror "You must add group ${g} to the system first"
710 die "${g} is not a valid GID" 540 die "${g} is not a valid GID"
711 fi 541 fi
712 if [ -z "${defgroup}" ] 542 if [[ -z ${defgroup} ]] ; then
713 then
714 defgroup="${g}" 543 defgroup=${g}
715 else 544 else
716 exgroups="${exgroups},${g}" 545 exgroups="${exgroups},${g}"
717 fi 546 fi
718 export IFS="," 547 export IFS=","
719 done 548 done
720 export IFS="${oldifs}" 549 export IFS=${oldifs}
721 550
722 opts="${opts} -g ${defgroup}" 551 opts="${opts} -g ${defgroup}"
723 if [ ! -z "${exgroups}" ] 552 if [[ ! -z ${exgroups} ]] ; then
724 then
725 opts="${opts} -G ${exgroups:1}" 553 opts="${opts} -G ${exgroups:1}"
726 fi 554 fi
727 else 555 else
728 egroups="(none)" 556 egroups="(none)"
729 fi 557 fi
730 einfo " - Groups: ${egroups}" 558 einfo " - Groups: ${egroups}"
731 559
732 # handle extra and add the user 560 # handle extra and add the user
733 local eextra="$@"
734 local oldsandbox="${SANDBOX_ON}" 561 local oldsandbox=${SANDBOX_ON}
735 export SANDBOX_ON="0" 562 export SANDBOX_ON="0"
736 if useq ppc-macos 563 case ${CHOST} in
737 then 564 *-darwin*)
738 ### Make the user 565 ### Make the user
739 if [ -z "${eextra}" ] 566 if [[ -z $@ ]] ; then
740 then
741 dscl . create /users/${euser} uid ${euid} 567 dscl . create /users/${euser} uid ${euid}
742 dscl . create /users/${euser} shell ${eshell} 568 dscl . create /users/${euser} shell ${eshell}
743 dscl . create /users/${euser} home ${ehome} 569 dscl . create /users/${euser} home ${ehome}
744 dscl . create /users/${euser} realname "added by portage for ${PN}" 570 dscl . create /users/${euser} realname "added by portage for ${PN}"
745 ### Add the user to the groups specified 571 ### Add the user to the groups specified
746 local oldifs="${IFS}" 572 local oldifs=${IFS}
747 export IFS="," 573 export IFS=","
748 for g in ${egroups} 574 for g in ${egroups} ; do
749 do
750 dscl . merge /groups/${g} users ${euser} 575 dscl . merge /groups/${g} users ${euser}
751 done 576 done
752 export IFS="${oldifs}" 577 export IFS=${oldifs}
753 else 578 else
754 einfo "Extra options are not supported on macos yet" 579 einfo "Extra options are not supported on Darwin yet"
755 einfo "Please report the ebuild along with the info below" 580 einfo "Please report the ebuild along with the info below"
756 einfo "eextra: ${eextra}" 581 einfo "eextra: $@"
757 die "Required function missing" 582 die "Required function missing"
758 fi 583 fi
759 elif use x86-fbsd ; then 584 ;;
760 if [ -z "${eextra}" ] 585 *-freebsd*)
761 then 586 if [[ -z $@ ]] ; then
762 pw useradd ${euser} ${opts} \ 587 pw useradd ${euser} ${opts} \
763 -c "added by portage for ${PN}" \ 588 -c "added by portage for ${PN}" \
764 die "enewuser failed" 589 die "enewuser failed"
765 else 590 else
766 einfo " - Extra: ${eextra}" 591 einfo " - Extra: $@"
767 pw useradd ${euser} ${opts} \ 592 pw useradd ${euser} ${opts} \
768 -c ${eextra} || die "enewuser failed" 593 "$@" || die "enewuser failed"
769 fi 594 fi
595 ;;
596
597 *-netbsd*)
598 if [[ -z $@ ]] ; then
599 useradd ${opts} ${euser} || die "enewuser failed"
770 else 600 else
771 if [ -z "${eextra}" ] 601 einfo " - Extra: $@"
772 then 602 useradd ${opts} ${euser} "$@" || die "enewuser failed"
603 fi
604 ;;
605 *)
606 if [[ -z $@ ]] ; then
773 useradd ${opts} ${euser} \ 607 useradd ${opts} ${euser} \
774 -c "added by portage for ${PN}" \ 608 -c "added by portage for ${PN}" \
775 || die "enewuser failed" 609 || die "enewuser failed"
776 else 610 else
777 einfo " - Extra: ${eextra}" 611 einfo " - Extra: $@"
778 useradd ${opts} ${euser} ${eextra} \ 612 useradd ${opts} ${euser} "$@" \
779 || die "enewuser failed" 613 || die "enewuser failed"
780 fi 614 fi
615 ;;
616 esac
617
618 if [[ ! -e ${ROOT}/${ehome} ]] ; then
619 einfo " - Creating ${ehome} in ${ROOT}"
620 mkdir -p "${ROOT}/${ehome}"
621 chown ${euser} "${ROOT}/${ehome}"
622 chmod 755 "${ROOT}/${ehome}"
781 fi 623 fi
624
782 export SANDBOX_ON="${oldsandbox}" 625 export SANDBOX_ON=${oldsandbox}
783
784 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
785 then
786 einfo " - Creating ${ehome} in ${D}"
787 dodir ${ehome}
788 fowners ${euser} ${ehome}
789 fperms 755 ${ehome}
790 fi
791} 626}
792 627
793# Simplify/standardize adding groups to the system 628# Simplify/standardize adding groups to the system
794# vapier@gentoo.org 629# vapier@gentoo.org
795# 630#
824 then 659 then
825 if [ "${egid}" -gt 0 ] 660 if [ "${egid}" -gt 0 ]
826 then 661 then
827 if [ -z "`egetent group ${egid}`" ] 662 if [ -z "`egetent group ${egid}`" ]
828 then 663 then
829 if useq ppc-macos ; then 664 if [[ "${CHOST}" == *-darwin* ]]; then
830 opts="${opts} ${egid}" 665 opts="${opts} ${egid}"
831 else 666 else
832 opts="${opts} -g ${egid}" 667 opts="${opts} -g ${egid}"
833 fi 668 fi
834 else 669 else
848 opts="${opts} ${eextra}" 683 opts="${opts} ${eextra}"
849 684
850 # add the group 685 # add the group
851 local oldsandbox="${SANDBOX_ON}" 686 local oldsandbox="${SANDBOX_ON}"
852 export SANDBOX_ON="0" 687 export SANDBOX_ON="0"
853 if useq ppc-macos ; then 688 case ${CHOST} in
689 *-darwin*)
854 if [ ! -z "${eextra}" ]; 690 if [ ! -z "${eextra}" ];
855 then 691 then
856 einfo "Extra options are not supported on macos yet" 692 einfo "Extra options are not supported on Darwin/OS X yet"
857 einfo "Please report the ebuild along with the info below" 693 einfo "Please report the ebuild along with the info below"
858 einfo "eextra: ${eextra}" 694 einfo "eextra: ${eextra}"
859 die "Required function missing" 695 die "Required function missing"
860 fi 696 fi
861 697
862 # If we need the next available 698 # If we need the next available
863 case ${egid} in 699 case ${egid} in
864 *[!0-9]*) # Non numeric 700 *[!0-9]*) # Non numeric
865 for egid in `jot 898 101`; do 701 for egid in $(seq 101 999); do
866 [ -z "`egetent group ${egid}`" ] && break 702 [ -z "`egetent group ${egid}`" ] && break
867 done 703 done
868 esac 704 esac
869 dscl . create /groups/${egroup} gid ${egid} 705 dscl . create /groups/${egroup} gid ${egid}
870 dscl . create /groups/${egroup} passwd '*' 706 dscl . create /groups/${egroup} passwd '*'
871 elif use x86-fbsd ; then 707 ;;
708
709 *-freebsd*)
872 case ${egid} in 710 case ${egid} in
873 *[!0-9]*) # Non numeric 711 *[!0-9]*) # Non numeric
874 for egid in `jot 898 101`; do 712 for egid in $(seq 101 999); do
875 [ -z "`egetent group ${egid}`" ] && break 713 [ -z "`egetent group ${egid}`" ] && break
876 done 714 done
877 esac 715 esac
878 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 716 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
879 else 717 ;;
718
719 *-netbsd*)
720 case ${egid} in
721 *[!0-9]*) # Non numeric
722 for egid in $(seq 101 999); do
723 [ -z "`egetent group ${egid}`" ] && break
724 done
725 esac
726 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
727 ;;
728
729 *)
880 groupadd ${opts} ${egroup} || die "enewgroup failed" 730 groupadd ${opts} ${egroup} || die "enewgroup failed"
881 fi 731 ;;
732 esac
882 export SANDBOX_ON="${oldsandbox}" 733 export SANDBOX_ON="${oldsandbox}"
883} 734}
884 735
885# Simple script to replace 'dos2unix' binaries 736# Simple script to replace 'dos2unix' binaries
886# vapier@gentoo.org 737# vapier@gentoo.org
911# name: the name that will show up in the menu 762# name: the name that will show up in the menu
912# icon: give your little like a pretty little icon ... 763# icon: give your little like a pretty little icon ...
913# this can be relative (to /usr/share/pixmaps) or 764# this can be relative (to /usr/share/pixmaps) or
914# a full path to an icon 765# a full path to an icon
915# type: what kind of application is this ? for categories: 766# type: what kind of application is this ? for categories:
916# http://www.freedesktop.org/standards/menu-spec/ 767# http://www.freedesktop.org/Standards/desktop-entry-spec
917# path: if your app needs to startup in a specific dir 768# path: if your app needs to startup in a specific dir
918make_desktop_entry() { 769make_desktop_entry() {
919 [ -z "$1" ] && eerror "make_desktop_entry: You must specify the executable" && return 1 770 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1
920 771
921 local exec="${1}" 772 local exec=${1}
922 local name="${2:-${PN}}" 773 local name=${2:-${PN}}
923 local icon="${3:-${PN}.png}" 774 local icon=${3:-${PN}.png}
924 local type="${4}" 775 local type=${4}
925 local subdir="${6}" 776 local path=${5}
926 local path="${5:-${GAMES_BINDIR}}" 777
927 if [ -z "${type}" ] 778 if [[ -z ${type} ]] ; then
928 then 779 local catmaj=${CATEGORY%%-*}
929 case ${CATEGORY} in 780 local catmin=${CATEGORY##*-}
930 "app-emulation") 781 case ${catmaj} in
931 type=Emulator 782 app)
932 subdir="Emulation" 783 case ${catmin} in
784 admin) type=System;;
785 cdr) type=DiscBurning;;
786 dicts) type=Dictionary;;
787 editors) type=TextEditor;;
788 emacs) type=TextEditor;;
789 emulation) type=Emulator;;
790 laptop) type=HardwareSettings;;
791 office) type=Office;;
792 vim) type=TextEditor;;
793 xemacs) type=TextEditor;;
794 *) type=;;
795 esac
933 ;; 796 ;;
934 "games-"*) 797
935 type=Game 798 dev)
936 subdir="Games" 799 type="Development"
937 ;; 800 ;;
938 "net-"*) 801
939 type=Network 802 games)
940 subdir="${type}" 803 case ${catmin} in
804 action) type=ActionGame;;
805 arcade) type=ArcadeGame;;
806 board) type=BoardGame;;
807 kid) type=KidsGame;;
808 emulation) type=Emulator;;
809 puzzle) type=LogicGame;;
810 rpg) type=RolePlaying;;
811 roguelike) type=RolePlaying;;
812 simulation) type=Simulation;;
813 sports) type=SportsGame;;
814 strategy) type=StrategyGame;;
815 *) type=;;
816 esac
817 type="Game;${type}"
941 ;; 818 ;;
819
820 mail)
821 type="Network;Email"
822 ;;
823
824 media)
825 case ${catmin} in
826 gfx) type=Graphics;;
827 radio) type=Tuner;;
828 sound) type=Audio;;
829 tv) type=TV;;
830 video) type=Video;;
831 *) type=;;
832 esac
833 type="AudioVideo;${type}"
834 ;;
835
836 net)
837 case ${catmin} in
838 dialup) type=Dialup;;
839 ftp) type=FileTransfer;;
840 im) type=InstantMessaging;;
841 irc) type=IRCClient;;
842 mail) type=Email;;
843 news) type=News;;
844 nntp) type=News;;
845 p2p) type=FileTransfer;;
846 *) type=;;
847 esac
848 type="Network;${type}"
849 ;;
850
851 sci)
852 case ${catmin} in
853 astro*) type=Astronomoy;;
854 bio*) type=Biology;;
855 calc*) type=Calculator;;
856 chem*) type=Chemistry;;
857 geo*) type=Geology;;
858 math*) type=Math;;
859 *) type=;;
860 esac
861 type="Science;${type}"
862 ;;
863
864 www)
865 case ${catmin} in
866 client) type=WebBrowser;;
867 *) type=;;
868 esac
869 type="Network"
870 ;;
871
942 *) 872 *)
943 type= 873 type=
944 subdir=
945 ;; 874 ;;
946 esac 875 esac
947 fi 876 fi
877 if [ "${SLOT}" == "0" ] ; then
878 local desktop_name="${PN}"
879 else
880 local desktop_name="${PN}-${SLOT}"
881 fi
948 local desktop="${T}/${exec}.desktop" 882 local desktop=${T}/${exec%% *}-${desktop_name}.desktop
949 883
950echo "[Desktop Entry] 884echo "[Desktop Entry]
951Encoding=UTF-8 885Encoding=UTF-8
952Version=0.9.2 886Version=0.9.2
953Name=${name} 887Name=${name}
956Exec=${exec} 890Exec=${exec}
957Path=${path} 891Path=${path}
958Icon=${icon} 892Icon=${icon}
959Categories=Application;${type};" > "${desktop}" 893Categories=Application;${type};" > "${desktop}"
960 894
895 (
896 # wrap the env here so that the 'insinto' call
897 # doesn't corrupt the env of the caller
961 insinto /usr/share/applications 898 insinto /usr/share/applications
962 doins "${desktop}" 899 doins "${desktop}"
963 900 )
964 return 0
965} 901}
966 902
967# Make a GDM/KDM Session file 903# Make a GDM/KDM Session file
968# 904#
969# make_desktop_entry(<title>, <command>) 905# make_desktop_entry(<title>, <command>)
970# title: File to execute to start the Window Manager 906# title: File to execute to start the Window Manager
971# command: Name of the Window Manager 907# command: Name of the Window Manager
972 908
973make_session_desktop() { 909make_session_desktop() {
974
975 [ -z "$1" ] && eerror "make_session_desktop: You must specify the title" && return 1 910 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1
976 [ -z "$2" ] && eerror "make_session_desktop: You must specify the command" && return 1 911 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1
977 912
978 local title="${1}" 913 local title=$1
979 local command="${2}" 914 local command=$2
980 local desktop="${T}/${wm}.desktop" 915 local desktop=${T}/${wm}.desktop
981 916
982echo "[Desktop Entry] 917echo "[Desktop Entry]
983Encoding=UTF-8 918Encoding=UTF-8
984Name=${title} 919Name=${title}
985Comment=This session logs you into ${title} 920Comment=This session logs you into ${title}
987TryExec=${command} 922TryExec=${command}
988Type=Application" > "${desktop}" 923Type=Application" > "${desktop}"
989 924
990 insinto /usr/share/xsessions 925 insinto /usr/share/xsessions
991 doins "${desktop}" 926 doins "${desktop}"
992
993 return 0
994} 927}
995 928
996domenu() { 929domenu() {
997 local i 930 local i j
998 local j
999 insinto /usr/share/applications 931 insinto /usr/share/applications
1000 for i in ${@} 932 for i in "$@" ; do
1001 do
1002 if [ -f "${i}" ]; 933 if [[ -f ${i} ]] ; then
1003 then
1004 doins ${i} 934 doins "${i}"
1005 elif [ -d "${i}" ]; 935 elif [[ -d ${i} ]] ; then
1006 then
1007 for j in ${i}/*.desktop 936 for j in "${i}"/*.desktop ; do
1008 do
1009 doins ${j} 937 doins "${j}"
1010 done 938 done
1011 fi 939 fi
1012 done 940 done
1013} 941}
942newmenu() {
943 insinto /usr/share/applications
944 newins "$1" "$2"
945}
1014 946
1015doicon() { 947doicon() {
1016 local i 948 local i j
1017 local j
1018 insinto /usr/share/pixmaps 949 insinto /usr/share/pixmaps
1019 for i in ${@} 950 for i in "$@" ; do
1020 do
1021 if [ -f "${i}" ]; 951 if [[ -f ${i} ]] ; then
1022 then
1023 doins ${i} 952 doins "${i}"
1024 elif [ -d "${i}" ]; 953 elif [[ -d ${i} ]] ; then
1025 then
1026 for j in ${i}/*.png 954 for j in "${i}"/*.png ; do
1027 do
1028 doins ${j} 955 doins "${j}"
1029 done 956 done
1030 fi 957 fi
1031 done 958 done
959}
960newicon() {
961 insinto /usr/share/pixmaps
962 newins "$1" "$2"
1032} 963}
1033 964
1034############################################################## 965##############################################################
1035# END: Handle .desktop files and menu entries # 966# END: Handle .desktop files and menu entries #
1036############################################################## 967##############################################################
1037 968
1038 969
1039# for internal use only (unpack_pdv and unpack_makeself) 970# for internal use only (unpack_pdv and unpack_makeself)
1040find_unpackable_file() { 971find_unpackable_file() {
1041 local src="$1" 972 local src=$1
1042 if [ -z "${src}" ] 973 if [[ -z ${src} ]] ; then
1043 then
1044 src="${DISTDIR}/${A}" 974 src=${DISTDIR}/${A}
1045 else 975 else
1046 if [ -e "${DISTDIR}/${src}" ] 976 if [[ -e ${DISTDIR}/${src} ]] ; then
1047 then
1048 src="${DISTDIR}/${src}" 977 src=${DISTDIR}/${src}
1049 elif [ -e "${PWD}/${src}" ] 978 elif [[ -e ${PWD}/${src} ]] ; then
1050 then
1051 src="${PWD}/${src}" 979 src=${PWD}/${src}
1052 elif [ -e "${src}" ] 980 elif [[ -e ${src} ]] ; then
1053 then
1054 src="${src}" 981 src=${src}
1055 fi
1056 fi 982 fi
1057 [ ! -e "${src}" ] && die "Could not find requested archive ${src}" 983 fi
984 [[ ! -e ${src} ]] && return 1
1058 echo "${src}" 985 echo "${src}"
1059} 986}
1060 987
1061# Unpack those pesky pdv generated files ... 988# Unpack those pesky pdv generated files ...
1062# They're self-unpacking programs with the binary package stuffed in 989# They're self-unpacking programs with the binary package stuffed in
1077# lseek 1004# lseek
1078# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1005# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1079# lseek(3, -4, SEEK_END) = 2981250 1006# lseek(3, -4, SEEK_END) = 2981250
1080# thus we would pass in the value of '4' as the second parameter. 1007# thus we would pass in the value of '4' as the second parameter.
1081unpack_pdv() { 1008unpack_pdv() {
1082 local src="`find_unpackable_file $1`" 1009 local src=$(find_unpackable_file $1)
1083 local sizeoff_t="$2" 1010 local sizeoff_t=$2
1084 1011
1012 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1085 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :(" 1013 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1086 1014
1087 local shrtsrc="`basename ${src}`" 1015 local shrtsrc=$(basename "${src}")
1088 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1016 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1089 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1017 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1090 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1018 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1091 1019
1092 # grab metadata for debug reasons 1020 # grab metadata for debug reasons
1156# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1084# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1157# - If the file is not specified then unpack will utilize ${A}. 1085# - If the file is not specified then unpack will utilize ${A}.
1158# - If the offset is not specified then we will attempt to extract 1086# - If the offset is not specified then we will attempt to extract
1159# the proper offset from the script itself. 1087# the proper offset from the script itself.
1160unpack_makeself() { 1088unpack_makeself() {
1161 local src="$(find_unpackable_file "$1")" 1089 local src=$(find_unpackable_file "$1")
1162 local skip="$2" 1090 local skip=$2
1163 local exe="$3" 1091 local exe=$3
1164 1092
1093 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1094
1165 local shrtsrc="$(basename "${src}")" 1095 local shrtsrc=$(basename "${src}")
1166 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1096 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1167 if [ -z "${skip}" ] 1097 if [[ -z ${skip} ]] ; then
1168 then
1169 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1098 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1170 local skip=0 1099 local skip=0
1171 exe=tail 1100 exe=tail
1172 case ${ver} in 1101 case ${ver} in
1173 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1102 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1174 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1103 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1186 ;; 1115 ;;
1187 2.1.3) 1116 2.1.3)
1188 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1117 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1189 let skip="skip + 1" 1118 let skip="skip + 1"
1190 ;; 1119 ;;
1191 2.1.4) 1120 2.1.4|2.1.5)
1192 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1121 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1193 skip=$(head -n ${skip} "${src}" | wc -c) 1122 skip=$(head -n ${skip} "${src}" | wc -c)
1194 exe="dd" 1123 exe="dd"
1195 ;; 1124 ;;
1196 *) 1125 *)
1241check_license() { 1170check_license() {
1242 local lic=$1 1171 local lic=$1
1243 if [ -z "${lic}" ] ; then 1172 if [ -z "${lic}" ] ; then
1244 lic="${PORTDIR}/licenses/${LICENSE}" 1173 lic="${PORTDIR}/licenses/${LICENSE}"
1245 else 1174 else
1246 if [ -e "${PORTDIR}/licenses/${src}" ] ; then 1175 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1247 lic="${PORTDIR}/licenses/${src}" 1176 lic="${PORTDIR}/licenses/${lic}"
1248 elif [ -e "${PWD}/${src}" ] ; then 1177 elif [ -e "${PWD}/${lic}" ] ; then
1249 lic="${PWD}/${src}" 1178 lic="${PWD}/${lic}"
1250 elif [ -e "${src}" ] ; then 1179 elif [ -e "${lic}" ] ; then
1251 lic="${src}" 1180 lic="${lic}"
1252 fi
1253 fi 1181 fi
1182 fi
1254 [ ! -f "${lic}" ] && die "Could not find requested license ${src}" 1183 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1255 local l="`basename ${lic}`" 1184 local l="`basename ${lic}`"
1256 1185
1257 # here is where we check for the licenses the user already 1186 # here is where we check for the licenses the user already
1258 # accepted ... if we don't find a match, we make the user accept 1187 # accepted ... if we don't find a match, we make the user accept
1259 local shopts=$- 1188 local shopts=$-
1430# displayed and we'll hang out here until: 1359# displayed and we'll hang out here until:
1431# (1) the file is found on a mounted cdrom 1360# (1) the file is found on a mounted cdrom
1432# (2) the user hits CTRL+C 1361# (2) the user hits CTRL+C
1433cdrom_locate_file_on_cd() { 1362cdrom_locate_file_on_cd() {
1434 while [[ -z ${CDROM_ROOT} ]] ; do 1363 while [[ -z ${CDROM_ROOT} ]] ; do
1435 local dir="$(dirname ${@})" 1364 local dir=$(dirname "$*")
1436 local file="$(basename ${@})" 1365 local file=$(basename "$*")
1437 local mline="" 1366 local mline=""
1438 local showedmsg=0 1367 local showedmsg=0
1439 1368
1440 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1369 for mline in $(mount | egrep -e '(iso|cdrom|fs=cdfss)' | awk '{print $3}') ; do
1441 [[ -d ${mline}/${dir} ]] || continue 1370 [[ -d ${mline}/${dir} ]] || continue
1442 [[ ! -z $(find ${mline}/${dir} -iname ${file} -maxdepth 1) ]] \ 1371 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \
1443 && export CDROM_ROOT=${mline} 1372 && export CDROM_ROOT=${mline}
1444 done 1373 done
1445 1374
1446 if [[ -z ${CDROM_ROOT} ]] ; then 1375 if [[ -z ${CDROM_ROOT} ]] ; then
1447 echo 1376 echo
1462 fi 1391 fi
1463 showedmsg=1 1392 showedmsg=1
1464 fi 1393 fi
1465 einfo "Press return to scan for the cd again" 1394 einfo "Press return to scan for the cd again"
1466 einfo "or hit CTRL+C to abort the emerge." 1395 einfo "or hit CTRL+C to abort the emerge."
1396 echo
1397 einfo "If you are having trouble with the detection"
1398 einfo "of your CD, it is possible that you do not have"
1399 einfo "Joliet support enabled in your kernel. Please"
1400 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1467 read 1401 read
1468 fi 1402 fi
1469 done 1403 done
1470} 1404}
1471 1405
1481# directories and uses the intersection of the lists. 1415# directories and uses the intersection of the lists.
1482# The -u builds a list of po files found in all the 1416# The -u builds a list of po files found in all the
1483# directories and uses the union of the lists. 1417# directories and uses the union of the lists.
1484strip-linguas() { 1418strip-linguas() {
1485 local ls newls 1419 local ls newls
1486 if [ "$1" == "-i" ] || [ "$1" == "-u" ] ; then 1420 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1487 local op="$1"; shift 1421 local op=$1; shift
1488 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1422 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift
1489 local d f 1423 local d f
1490 for d in "$@" ; do 1424 for d in "$@" ; do
1491 if [ "${op}" == "-u" ] ; then 1425 if [[ ${op} == "-u" ]] ; then
1492 newls="${ls}" 1426 newls=${ls}
1493 else 1427 else
1494 newls="" 1428 newls=""
1495 fi 1429 fi
1496 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1430 for f in $(find "$d" -name '*.po' -printf '%f ') ; do
1497 if [ "${op}" == "-i" ] ; then 1431 if [[ ${op} == "-i" ]] ; then
1498 [ "${ls/ ${f} /}" != "${ls}" ] && newls="${newls} ${f}" 1432 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}"
1499 else 1433 else
1500 [ "${ls/ ${f} /}" == "${ls}" ] && newls="${newls} ${f}" 1434 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}"
1501 fi 1435 fi
1502 done 1436 done
1503 ls="${newls}" 1437 ls=${newls}
1504 done 1438 done
1505 ls="${ls//.po}" 1439 ls=${ls//.po}
1506 else 1440 else
1507 ls="$@" 1441 ls=$@
1508 fi 1442 fi
1509 1443
1510 ls=" ${ls} " 1444 ls=" ${ls} "
1511 newls="" 1445 newls=""
1512 for f in ${LINGUAS} ; do 1446 for f in ${LINGUAS} ; do
1513 if [ "${ls/ ${f} /}" != "${ls}" ] ; then 1447 if [[ ${ls/ ${f} /} != ${ls} ]] ; then
1514 newls="${newls} ${f}" 1448 newls="${newls} ${f}"
1515 else 1449 else
1516 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1450 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA"
1517 fi 1451 fi
1518 done 1452 done
1519 if [ -z "${newls}" ] ; then 1453 if [[ -z ${newls} ]] ; then
1520 unset LINGUAS 1454 export LINGUAS=""
1521 else 1455 else
1522 export LINGUAS="${newls}" 1456 export LINGUAS=${newls:1}
1523 fi 1457 fi
1524} 1458}
1525 1459
1526# moved from kernel.eclass since they are generally useful outside of 1460# moved from kernel.eclass since they are generally useful outside of
1527# kernel.eclass -iggy (20041002) 1461# kernel.eclass -iggy (20041002)
1535 while ((i--)) ; do 1469 while ((i--)) ; do
1536 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass" 1470 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1537 done 1471 done
1538 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}" 1472 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1539 case ${ARCH} in 1473 case ${ARCH} in
1540 x86) export ARCH="i386";; 1474 x86) export ARCH="i386";;
1541 amd64) export ARCH="x86_64";; 1475 amd64) export ARCH="x86_64";;
1542 hppa) export ARCH="parisc";; 1476 hppa) export ARCH="parisc";;
1543 mips) export ARCH="mips";; 1477 mips) export ARCH="mips";;
1544 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one! 1478 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1545 *) export ARCH="${ARCH}";; 1479 *) export ARCH="${ARCH}";;
1546 esac 1480 esac
1547} 1481}
1548 1482
1549# set's ARCH back to what portage expects 1483# set's ARCH back to what portage expects
1550set_arch_to_portage() { 1484set_arch_to_portage() {
1594 LIB=$1 1528 LIB=$1
1595 1529
1596 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1530 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then
1597 SONAME=`basename ${LIB}` 1531 SONAME=`basename ${LIB}`
1598 1532
1599 einfo "An old version of an installed library was detected on your system." 1533 ewarn "An old version of an installed library was detected on your system."
1600 einfo "In order to avoid breaking packages that link against is, this older version" 1534 ewarn "In order to avoid breaking packages that link against it, this older version"
1601 einfo "is not being removed. In order to make full use of this newer version," 1535 ewarn "is not being removed. In order to make full use of this newer version,"
1602 einfo "you will need to execute the following command:" 1536 ewarn "you will need to execute the following command:"
1603 einfo " revdep-rebuild --soname ${SONAME}" 1537 ewarn " revdep-rebuild --soname ${SONAME}"
1604 einfo 1538 ewarn
1605 einfo "After doing that, you can safely remove ${LIB}" 1539 ewarn "After doing that, you can safely remove ${LIB}"
1606 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild" 1540 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1607 fi 1541 fi
1608} 1542}
1609 1543
1610# Hack for people to figure out if a package was built with 1544# Hack for people to figure out if a package was built with
1611# certain USE flags 1545# certain USE flags
1657dopamd() { 1591dopamd() {
1658 [[ -z $1 ]] && die "dopamd requires at least one argument" 1592 [[ -z $1 ]] && die "dopamd requires at least one argument"
1659 1593
1660 use pam || return 0 1594 use pam || return 0
1661 1595
1662 insinto /etc/pam.d 1596 INSDESTTREE=/etc/pam.d \
1663 # these are the default doins options, but be explicit just in case
1664 insopts -m 0644 -o root -g root
1665 doins "$@" || die "failed to install $@" 1597 doins "$@" || die "failed to install $@"
1666} 1598}
1667# newpamd <old name> <new name> 1599# newpamd <old name> <new name>
1668# 1600#
1669# Install pam file <old name> as <new name> in /etc/pam.d 1601# Install pam file <old name> as <new name> in /etc/pam.d
1670newpamd() { 1602newpamd() {
1671 [[ $# -ne 2 ]] && die "newpamd requires two arguements" 1603 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1672 1604
1673 use pam || return 0 1605 use pam || return 0
1674 1606
1675 insinto /etc/pam.d 1607 INSDESTTREE=/etc/pam.d \
1676 # these are the default doins options, but be explicit just in case
1677 insopts -m 0644 -o root -g root
1678 newins "$1" "$2" || die "failed to install $1 as $2" 1608 newins "$1" "$2" || die "failed to install $1 as $2"
1679} 1609}
1610
1611# make a wrapper script ...
1612# NOTE: this was originally games_make_wrapper, but I noticed other places where
1613# this could be used, so I have moved it here and made it not games-specific
1614# -- wolf31o2
1615# $1 == wrapper name
1616# $2 == binary to run
1617# $3 == directory to chdir before running binary
1618# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1619# $5 == path for wrapper
1620make_wrapper() {
1621 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1622 local tmpwrapper=$(emktemp)
1623 # We don't want to quote ${bin} so that people can pass complex
1624 # things as $bin ... "./someprog --args"
1625 cat << EOF > "${tmpwrapper}"
1626#!/bin/sh
1627cd "${chdir:-.}"
1628if [ -n "${libdir}" ] ; then
1629 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1630 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1631 else
1632 export LD_LIBRARY_PATH="${libdir}"
1633 fi
1634fi
1635exec ${bin} "\$@"
1636EOF
1637 chmod go+rx "${tmpwrapper}"
1638 if [[ -n ${path} ]] ; then
1639 exeinto "${path}"
1640 newexe "${tmpwrapper}" "${wrapper}"
1641 else
1642 newbin "${tmpwrapper}" "${wrapper}"
1643 fi
1644}

Legend:
Removed from v.1.152  
changed lines
  Added in v.1.212

  ViewVC Help
Powered by ViewVC 1.1.20